/*
 * {			Speechintf for Macintalk
 * 
 * AUTHOR
 *       Pascal Interfaces for MPW modified by Mike Millen
 *       Copyright 1983, 1984, 1985, 1986 Apple Computer Inc. All Rights Reserved
 * 
 * 		 MPW C version by J. B. Levin September, 1988
 * BUGS
 * }
 */	

#ifndef __SPEECH__
#define __SPEECH__
#ifndef __TYPES__
#include <Types.h>
#endif

#define noExcpsFiles	""			/* signals Reader to use only basic rules */
#define noReader		"noReader"	/* signals SpeechOn to NOT bring in Reader */
#define fullUnitT		-4000		/* error code for driver unit table full */

typedef short			SpeechErr;
typedef char			SpeechRecord[100];	/* Driver parm block, used internally */
typedef SpeechRecord	*SpeechPointer,		/* pointer to driver parm block */
						**SpeechHandle;		/* handle to driver parm block */

typedef enum { Male, Female }								Sex;
typedef enum { Natural, Robotic, NoChange }					FOMode;
typedef enum { English, French, Spanish, German, Italian }	Language;

typedef struct VoiceRecord {
	Sex			theSex;
	Language	theLanguage;
	short		theRate;
	short		thePitch;
	FOMode		theMode;
	Str255		theName;
	long			refCon;
					} VoiceRecord, *VoicePtr;

pascal SpeechErr SpeechOn (ExcpsFile, theSpeech)
	StringPtr		ExcpsFile;
	SpeechHandle	*theSpeech;
	extern;
	
pascal void SpeechOff (theSpeech)
	SpeechHandle	theSpeech;
	extern;
	
pascal void SpeechRate (theSpeech, theRate)
	SpeechHandle	theSpeech;
	short			theRate;
	extern;

pascal void SpeechPitch (theSpeech, thePitch, theMode)
	SpeechHandle	theSpeech;
	short			thePitch;
	FOMode			theMode;
	extern;
	
pascal void SpeechSex (theSpeech, theSex)
	SpeechHandle	theSpeech;
	Sex				theSex;
	extern;

pascal SpeechErr Reader (theSpeech, EnglishInput,
							InputLength, PhoneticOutput)
	SpeechHandle	theSpeech;
	Ptr				EnglishInput;
	long			InputLength;
	Handle			PhoneticOutput;
	extern;

pascal SpeechErr MacinTalk (theSpeech, Phonemes)
	SpeechHandle	theSpeech;
	Handle			Phonemes;
	extern;

#endif	
